// MPSReaderDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MPSReader.h"
#include "MPSReaderDlg.h"
#include "NumDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMPSReaderDlg dialog

CMPSReaderDlg::CMPSReaderDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMPSReaderDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMPSReaderDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMPSReaderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMPSReaderDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMPSReaderDlg, CDialog)
	//{{AFX_MSG_MAP(CMPSReaderDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()		
	ON_BN_CLICKED(IDC_OBJ, OnObj)
	ON_BN_CLICKED(IDC_CONSTRAINT, OnConstraint)
	ON_BN_CLICKED(IDC_COL, OnCol)
	ON_BN_CLICKED(IDC_ROW, OnRow)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_CLOSE, OnFileClose)
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
	ON_BN_CLICKED(IDC_EQ, OnEq)
	ON_BN_CLICKED(IDC_EDIT_DISABLE, OnEditDisable)
	ON_BN_CLICKED(IDC_EDIT_ENABLE, OnEditEnable)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMPSReaderDlg message handlers

BOOL CMPSReaderDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	
	
	HRESULT hresult;		

	CLSID clsid;
	
	//initialize COM library 
	CoInitialize(NULL);	
	hresult = CLSIDFromProgID(OLESTR("MPSfileReader.LPModel"),&clsid); 

	// Creaste COM instance 
	hresult = CoCreateInstance(clsid,NULL,CLSCTX_INPROC_SERVER,__uuidof(_LPModel),(LPVOID *) &pMPSReader); 	
	if(FAILED(hresult))
	{
		AfxMessageBox("Failed to create COM instance");
		exit(-1);
	}
	
	// set the edit-enable radio button to false 
	enable = FALSE;
	CheckRadioButton (IDC_EDIT_ENABLE, IDC_EDIT_DISABLE, IDC_EDIT_DISABLE);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMPSReaderDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMPSReaderDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMPSReaderDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CMPSReaderDlg::OnObj() 
{
	// get the objective row number 
	CNumDialog *dlg = new CNumDialog(this, 2 , pMPSReader);	
	dlg->DoModal();
	
	// call the DLL to display the selected objective row 
	pMPSReader->ViewNonBindingRow(dlg->getNum(), &enable);			

	// Check if the user opened a new MPS file 
	CheckforNewFile();
}


void CMPSReaderDlg::OnConstraint() 
{	
	// get the row number
	CNumDialog *dlg = new CNumDialog(this, 3, pMPSReader);
	dlg->DoModal();
	
	// Display the selected binding row 
	pMPSReader->ViewBindingRow(dlg->getNum(), &enable);	
	
	// Check if the user opened a new MPS file 
	CheckforNewFile();
}


void CMPSReaderDlg::OnCol() 
{
	// get the column number	
	CNumDialog *dlg = new CNumDialog(this, 1, pMPSReader);
	dlg->DoModal();
	
	// display the selected column
	pMPSReader->ViewCol(dlg->getNum(), &enable);	
	
	// Check if the user opened a new MPS file 
	CheckforNewFile();	
}

void CMPSReaderDlg::OnRow() 
{
	// get the row number
	CNumDialog *dlg = new CNumDialog(this, 0 , pMPSReader);	
	dlg->DoModal();
	
	// display the selected row
	pMPSReader->ViewRow(dlg->getNum(), &enable);		
	
	// Check if the user opened a new MPS file 
	CheckforNewFile();
}

void CMPSReaderDlg::OnEq() 
{
	pMPSReader->ViewEquations(&enable);		

	// Check if the user opened a new MPS file 
	CheckforNewFile();
}


void CMPSReaderDlg::OnEditEnable() 
{	
	enable = TRUE;
}

void CMPSReaderDlg::OnEditDisable() 
{
	enable = FALSE;
}

//--------------------------------------------------------------
// Menue handling 

void CMPSReaderDlg::OnFileNew() 
{
	// call the DLL to create a new MPS file.
	pMPSReader->NewMPSModel	();		
	CheckforNewFile();
}

void CMPSReaderDlg::OnFileOpen() 
{
	// call the DLL to read an exiting MPS file 
	if (pMPSReader->ReadMPSFile () == -1) {
		CheckforNewFile();
	}
}

void CMPSReaderDlg::OnFileClose() 
{	
	// close the currently opened MPS file 

	DisplayButtons(false);
	DisplayText(false);
	this->Invalidate ();
}

void CMPSReaderDlg::OnFileExit() 
{
	CoUninitialize();  //Unintialize the COM library	
	this->EndDialog(0);	
}

void CMPSReaderDlg::OnHelpAbout() 
{
	CDialog *dlg = new CDialog(IDD_AUTHORS); 
	dlg->DoModal();	
}

void CMPSReaderDlg::CheckforNewFile()
{
	CWnd *pWnd;
	CString str;
	
	// check if the MPS file is closed 

	if (strcmp (pMPSReader->FileLocation, "") == 0) {
		OnFileClose();
	}

	// an MPS file still open
	pWnd= this->GetDlgItem(IDC_LOCATION_2);
	pWnd->GetWindowText(str);

	// check if DLL has a new MPS file opened. 
	if (strcmp (str,pMPSReader->FileLocation)) 
	{		
		DisplayText(true);
		DisplayButtons(true);
		this->Invalidate ();
	}
}


void CMPSReaderDlg::DisplayButtons(bool enable)
{
	CWnd *pWnd;
	unsigned long add, remove;
	
	// Display or Hide the dialog control buttons
	
	if (enable == true)	{
		add    = WS_VISIBLE;
		remove = 0;
	}	else 	{
		add    = 0;
		remove = WS_VISIBLE;
	}
	
	pWnd= this->GetDlgItem(IDC_STATIC);
	pWnd->ModifyStyle(remove, add);

	pWnd= this->GetDlgItem(IDC_EQ);
	pWnd->ModifyStyle(remove, add);

	pWnd= this->GetDlgItem(IDC_COL);
	pWnd->ModifyStyle(remove, add);

	pWnd= this->GetDlgItem(IDC_ROW);
	pWnd->ModifyStyle(remove, add);

	pWnd= this->GetDlgItem(IDC_OBJ);
	pWnd->ModifyStyle(remove, add);

	pWnd= this->GetDlgItem(IDC_CONSTRAINT);
	pWnd->ModifyStyle(remove, add);

	pWnd= this->GetDlgItem(IDC_EDIT_ENABLE);
	pWnd->ModifyStyle(remove, add);

	pWnd= this->GetDlgItem(IDC_EDIT_DISABLE);
	pWnd->ModifyStyle(remove, add);

	pWnd= this->GetDlgItem(IDC_STATIC_1);
	pWnd->ModifyStyle(remove, add);
}

void CMPSReaderDlg::DisplayText(bool enable)
{
	CWnd *pWnd;
	char str [16];

	pWnd= this->GetDlgItem(IDC_LOCATION_2);
	if (enable == true) {
		pWnd->SetWindowText (pMPSReader->FileLocation);
	} else {
		pWnd->SetWindowText ("");
	}
	
	pWnd= this->GetDlgItem(IDC_MOD_NAME_2);
	if (enable == true) {
		pWnd->SetWindowText (pMPSReader->ModelName);
	} else {
		pWnd->SetWindowText ("");
	}

	pWnd= this->GetDlgItem(IDC_ST_NUM_ROW_2);
	if (enable == true) {
		sprintf (str,"%d", pMPSReader->NumberOfRows);
		pWnd->SetWindowText (str);
	} else {
		pWnd->SetWindowText ("");
	}

	pWnd= this->GetDlgItem(IDC_ST_NUM_COL_2);
	
	if (enable == true) {
		sprintf (str,"%d", pMPSReader->NumberOfColumns);
		pWnd->SetWindowText (str);
	} else {
		pWnd->SetWindowText ("");
	}

	pWnd= this->GetDlgItem(IDC_ST_NUM_ELM_2);
	if (enable == true) {
		sprintf (str,"%d", pMPSReader->NumberOfElements);
		pWnd->SetWindowText (str);
	}	else {
		pWnd->SetWindowText ("");
	}
}

void CMPSReaderDlg::OnOK() 
{
}

void CMPSReaderDlg::OnCancel() 
{	
}
